RK-J - Bug #2198

Sometimes unable to generate the reports from the GUI.
03/17/2022 11:09 AM - Ayush Khandelwal

Status: Closed Start date: 03/17/2022
Priority: Urgent Due date: 05/20/2022
Assignee: Ayush Khandelwal % Done: 100%
Category: Estimated time: 0.00 hour
Target version: 1-RK-J-1 Spent time: 0.00 hour
Description

The reason is java.lang.OutOfMemoryError: Java heap space

Logs from QA:
https://console.cloud.google.com/logs/viewer?project=edutestga&minlLoglevel=0&expandAll=false&timestamp=2022-03-17T10%3A
35%3A05.504000000Z&customFacets&limitCustomFacetWidth=true&interval=CUSTOM&resource=gae_app&logName=projects%2
Fedutestqa%2Flogs%2Fstdout&logName=projects%2Fedutestqa%2Flogs%2F stderr&logName=projects%2Fedutestqa%2Flogs%2F
appengine.googleapis.com%252Frequest_log&scrollTimestamp=2022-03-17T05%3A18%3A58.069061000Z&dateRangeUnbound=b
oth&advancedFilter=resource.type%3D%22gae app%22%0Aresource.labels.project id%3D%22edutestqa%22%0Aresource.labels.
module_id%3D%22default%22%0Aresource.labels.zone%3D%22us-east1-5%22%0Aresource.labels.version_id%3D%2220220316t
234732%22%0Atimestamp%3D%222022-03-17T05%3A18%3A58.069061000Z2%22%0Ainsertld%3D%226232¢4c200039607 12430
3fe%22

History

#1 - 03/17/2022 11:37 AM - Venmuhilan B

- Status changed from New to In Progress

#2 - 03/17/2022 02:05 PM - Venmuhilan B

The followings are the things | did to find the reason for java.lang.OutOfMemoryError: Java heap space

Tested the top traffic by adding system.gc() at the end of the loop(loop for collecting and processing 100 by 100 logs every time until the size of the
logs) - the memory usage is not increasing continuously

Tested the top traffic by not adding system.gc() at the end of the loop(loop for collecting and processing 100 by 100 logs every time until the size of
the logs) - the memory usage is increasing continuously

converted the static methods to normal methods(without adding system.gc() at the end of the loop)

private static String getLogEntries(String accessToken, String nextPageToken, String projectld , String startTime , String endTime, SERVICE
serviceType)

private static JsonObject getTheRequestBody(String projectld, String startTime, String endTime, String nextPageToken, SERVICE serviceType)
private static String getTracesEntries(String accessToken, String nextPageToken, String projectld , String startTime , String endTime)

- the memory usage was still increasing continuously.

Added the code parts inside the loop in a separate method
- the memory usage was still increasing continuously.

Non-static Inner Class may cause memory leaks. TopTrafficMaps is an inner class present in the ExcelGeneration.java, | checked whether it is
defined as static or not. TopTrafficMaps is a static inner class.

To do:

Do the profiling technique to detect the memory leak. There are some profiling tools like JProfiler which can
be integrated into the eclipse.

TopTrafficMaps class is the class that has three maps where we are storing the details of the logs in the maps

for every 100 by 100 logs. Instead of using TopTrafficMaps, we can write the logs directly into the respectiv
e sheets of the workbook and see whether the memory usage is constantly increasing for this.

#3 - 03/21/2022 10:46 AM - Venmubhilan B
- Status changed from In Progress to Resolved

- % Done changed from 0 to 100

#4 - 05/17/2022 06:30 AM - Ayush Khandelwal
https://console.cloud.google.com/logs/viewer?project=edutestqa&minLogLevel=0&expandAll=false&timestamp=2022-03-17T10%3A35%3A05.504000000Z&customFacets&limitCustomFacetWidth=true&interval=CUSTOM&resource=gae_app&logName=projects%2Fedutestqa%2Flogs%2Fstdout&logName=projects%2Fedutestqa%2Flogs%2Fstderr&logName=projects%2Fedutestqa%2Flogs%2Fappengine.googleapis.com%252Frequest_log&scrollTimestamp=2022-03-17T05%3A18%3A58.069061000Z&dateRangeUnbound=both&advancedFilter=resource.type%3D%22gae_app%22%0Aresource.labels.project_id%3D%22edutestqa%22%0Aresource.labels.module_id%3D%22default%22%0Aresource.labels.zone%3D%22us-east1-5%22%0Aresource.labels.version_id%3D%2220220316t234732%22%0Atimestamp%3D%222022-03-17T05%3A18%3A58.069061000Z%22%0AinsertId%3D%226232c4c200039607124303fe%22
https://console.cloud.google.com/logs/viewer?project=edutestqa&minLogLevel=0&expandAll=false&timestamp=2022-03-17T10%3A35%3A05.504000000Z&customFacets&limitCustomFacetWidth=true&interval=CUSTOM&resource=gae_app&logName=projects%2Fedutestqa%2Flogs%2Fstdout&logName=projects%2Fedutestqa%2Flogs%2Fstderr&logName=projects%2Fedutestqa%2Flogs%2Fappengine.googleapis.com%252Frequest_log&scrollTimestamp=2022-03-17T05%3A18%3A58.069061000Z&dateRangeUnbound=both&advancedFilter=resource.type%3D%22gae_app%22%0Aresource.labels.project_id%3D%22edutestqa%22%0Aresource.labels.module_id%3D%22default%22%0Aresource.labels.zone%3D%22us-east1-5%22%0Aresource.labels.version_id%3D%2220220316t234732%22%0Atimestamp%3D%222022-03-17T05%3A18%3A58.069061000Z%22%0AinsertId%3D%226232c4c200039607124303fe%22
https://console.cloud.google.com/logs/viewer?project=edutestqa&minLogLevel=0&expandAll=false&timestamp=2022-03-17T10%3A35%3A05.504000000Z&customFacets&limitCustomFacetWidth=true&interval=CUSTOM&resource=gae_app&logName=projects%2Fedutestqa%2Flogs%2Fstdout&logName=projects%2Fedutestqa%2Flogs%2Fstderr&logName=projects%2Fedutestqa%2Flogs%2Fappengine.googleapis.com%252Frequest_log&scrollTimestamp=2022-03-17T05%3A18%3A58.069061000Z&dateRangeUnbound=both&advancedFilter=resource.type%3D%22gae_app%22%0Aresource.labels.project_id%3D%22edutestqa%22%0Aresource.labels.module_id%3D%22default%22%0Aresource.labels.zone%3D%22us-east1-5%22%0Aresource.labels.version_id%3D%2220220316t234732%22%0Atimestamp%3D%222022-03-17T05%3A18%3A58.069061000Z%22%0AinsertId%3D%226232c4c200039607124303fe%22
https://console.cloud.google.com/logs/viewer?project=edutestqa&minLogLevel=0&expandAll=false&timestamp=2022-03-17T10%3A35%3A05.504000000Z&customFacets&limitCustomFacetWidth=true&interval=CUSTOM&resource=gae_app&logName=projects%2Fedutestqa%2Flogs%2Fstdout&logName=projects%2Fedutestqa%2Flogs%2Fstderr&logName=projects%2Fedutestqa%2Flogs%2Fappengine.googleapis.com%252Frequest_log&scrollTimestamp=2022-03-17T05%3A18%3A58.069061000Z&dateRangeUnbound=both&advancedFilter=resource.type%3D%22gae_app%22%0Aresource.labels.project_id%3D%22edutestqa%22%0Aresource.labels.module_id%3D%22default%22%0Aresource.labels.zone%3D%22us-east1-5%22%0Aresource.labels.version_id%3D%2220220316t234732%22%0Atimestamp%3D%222022-03-17T05%3A18%3A58.069061000Z%22%0AinsertId%3D%226232c4c200039607124303fe%22
https://console.cloud.google.com/logs/viewer?project=edutestqa&minLogLevel=0&expandAll=false&timestamp=2022-03-17T10%3A35%3A05.504000000Z&customFacets&limitCustomFacetWidth=true&interval=CUSTOM&resource=gae_app&logName=projects%2Fedutestqa%2Flogs%2Fstdout&logName=projects%2Fedutestqa%2Flogs%2Fstderr&logName=projects%2Fedutestqa%2Flogs%2Fappengine.googleapis.com%252Frequest_log&scrollTimestamp=2022-03-17T05%3A18%3A58.069061000Z&dateRangeUnbound=both&advancedFilter=resource.type%3D%22gae_app%22%0Aresource.labels.project_id%3D%22edutestqa%22%0Aresource.labels.module_id%3D%22default%22%0Aresource.labels.zone%3D%22us-east1-5%22%0Aresource.labels.version_id%3D%2220220316t234732%22%0Atimestamp%3D%222022-03-17T05%3A18%3A58.069061000Z%22%0AinsertId%3D%226232c4c200039607124303fe%22
https://console.cloud.google.com/logs/viewer?project=edutestqa&minLogLevel=0&expandAll=false&timestamp=2022-03-17T10%3A35%3A05.504000000Z&customFacets&limitCustomFacetWidth=true&interval=CUSTOM&resource=gae_app&logName=projects%2Fedutestqa%2Flogs%2Fstdout&logName=projects%2Fedutestqa%2Flogs%2Fstderr&logName=projects%2Fedutestqa%2Flogs%2Fappengine.googleapis.com%252Frequest_log&scrollTimestamp=2022-03-17T05%3A18%3A58.069061000Z&dateRangeUnbound=both&advancedFilter=resource.type%3D%22gae_app%22%0Aresource.labels.project_id%3D%22edutestqa%22%0Aresource.labels.module_id%3D%22default%22%0Aresource.labels.zone%3D%22us-east1-5%22%0Aresource.labels.version_id%3D%2220220316t234732%22%0Atimestamp%3D%222022-03-17T05%3A18%3A58.069061000Z%22%0AinsertId%3D%226232c4c200039607124303fe%22
https://console.cloud.google.com/logs/viewer?project=edutestqa&minLogLevel=0&expandAll=false&timestamp=2022-03-17T10%3A35%3A05.504000000Z&customFacets&limitCustomFacetWidth=true&interval=CUSTOM&resource=gae_app&logName=projects%2Fedutestqa%2Flogs%2Fstdout&logName=projects%2Fedutestqa%2Flogs%2Fstderr&logName=projects%2Fedutestqa%2Flogs%2Fappengine.googleapis.com%252Frequest_log&scrollTimestamp=2022-03-17T05%3A18%3A58.069061000Z&dateRangeUnbound=both&advancedFilter=resource.type%3D%22gae_app%22%0Aresource.labels.project_id%3D%22edutestqa%22%0Aresource.labels.module_id%3D%22default%22%0Aresource.labels.zone%3D%22us-east1-5%22%0Aresource.labels.version_id%3D%2220220316t234732%22%0Atimestamp%3D%222022-03-17T05%3A18%3A58.069061000Z%22%0AinsertId%3D%226232c4c200039607124303fe%22
https://console.cloud.google.com/logs/viewer?project=edutestqa&minLogLevel=0&expandAll=false&timestamp=2022-03-17T10%3A35%3A05.504000000Z&customFacets&limitCustomFacetWidth=true&interval=CUSTOM&resource=gae_app&logName=projects%2Fedutestqa%2Flogs%2Fstdout&logName=projects%2Fedutestqa%2Flogs%2Fstderr&logName=projects%2Fedutestqa%2Flogs%2Fappengine.googleapis.com%252Frequest_log&scrollTimestamp=2022-03-17T05%3A18%3A58.069061000Z&dateRangeUnbound=both&advancedFilter=resource.type%3D%22gae_app%22%0Aresource.labels.project_id%3D%22edutestqa%22%0Aresource.labels.module_id%3D%22default%22%0Aresource.labels.zone%3D%22us-east1-5%22%0Aresource.labels.version_id%3D%2220220316t234732%22%0Atimestamp%3D%222022-03-17T05%3A18%3A58.069061000Z%22%0AinsertId%3D%226232c4c200039607124303fe%22

- Due date changed from 03/18/2022 to 05/20/2022

- Status changed from Resolved to Reopened

#5 - 05/17/2022 06:34 AM - Venmuhilan B

Used Gson Streaming:

You can use JSON Object/ JSON Array only if the size of your json data is less than 1MB. Else you should go with JSONReader. JSONReader
actually use streaming approach while JSONObject and JSONArray eventually load all the data on RAM at once which causes
OutOfMemoryException in case of bigger json.

(reference:

https://sites.google.com/site/gson/streaming
https://stackoverflow.com/questions/14742902/parse-json-data-using-jsonreader-or-jsonobject-jsonarray

)

#6 - 05/23/2022 06:44 AM - Venmuhilan B

- Status changed from Reopened to In Progress

#7 - 07/27/2022 04:49 AM - Ayush Khandelwal
- Status changed from In Progress to Closed

- Assignee changed from Venmuhilan B to Ayush Khandelwal

Untraceable. so, closing it for now

03/31/2025 22


https://sites.google.com/site/gson/streaming
https://stackoverflow.com/questions/14742902/parse-json-data-using-jsonreader-or-jsonobject-jsonarray
